import { ElementRef, EventEmitter, TemplateRef } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { HasId } from '../interfaces/has-id';
import * as i0 from "@angular/core";
export declare class BsSelect2Component<T extends HasId> {
    isOpen: boolean;
    suggestions$: BehaviorSubject<T[]>;
    isLoading$: BehaviorSubject<boolean>;
    defaultItemTemplate: TemplateRef<any>;
    searchBox: ElementRef<HTMLInputElement>;
    itemsBox: ElementRef<HTMLDivElement>;
    searchterm: string;
    suggestions: T[];
    provideSuggestions: EventEmitter<string>;
    selectedItems: T[];
    isFocused: boolean;
    private charWidth;
    searchWidth: number;
    itemTemplate?: TemplateRef<T>;
    suggestionTemplate?: TemplateRef<T>;
    onProvideSuggestions(value: string): void;
    onSuggestionClicked(suggestion: any): void;
    onRemoveItem(item: any, event: MouseEvent): void;
    focus(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSelect2Component<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsSelect2Component<any>, "bs-select2", never, { "searchterm": { "alias": "searchterm"; "required": false; }; "suggestions": { "alias": "suggestions"; "required": false; }; "selectedItems": { "alias": "selectedItems"; "required": false; }; }, { "provideSuggestions": "provideSuggestions"; }, never, never, false, never>;
}
